/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2005, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

*/

// TODO regexp modifier . match new ln

const nuISPNormal = 1;
const nuISPRelax = 2;

const nuISPAuthPost = 1;
const nuISPAuthGet = 2;
const nuISPAuthBasic = 3;
const nuISPAuthCustom = 4;
const nuISPAuthCookie = 5;
const nuISPAuthCookieGet = 6;

var nuSupportedISPs = {
'bigpond': 'Bigpond Broadband',
'netspace': 'Netspace ADSL',
'iinetb2': 'iiBroadband2 ADSL',
'iinet': 'iiNet bliink ADSL',
// 'westnet': 'WestNet ADSL',
'internode': 'Internode',
'optus': 'OptusNet Broadband',
'swiftdsl': 'Swiftbroadband',
'aanet': 'aaNet ADSL',
'exetel': 'eXeTeL ADSL',
'exetelwireless': 'eXeTeL Wireless',
'pacnet': 'Pacific Internet',
//'globaldial': 'Global Dial',
'tpgi': 'TPG Internet',
//'iprimus': 'iPrimus Broadband',
//'dataco': 'DataCo Broadband',
//'unwired': 'Unwired',


//canada
//'shaw': 'Shaw',
//'videotron': 'Videotron',

//'telecomnz': 'Telecom New Zealand',

//india
//'hathway': 'Hathway',

// potugal
'netcabo': 'Net cabo',
//'sapo': 'Sapo',

//Belgium
'coditel': 'Coditel.net',
}

function nuFillISPInterface(isp) {

	var month3l = {'Jan': 0, 'Feb': 1, 'Mar': 2, 'Apr': 3, 'May': 4, 'Jun': 5, 'Jul': 6, 'Aug': 7, 'Sep': 8, 'Oct': 9, 'Nov': 10, 'Dec': 11};


	switch(isp) {
	case 'bigpond':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPRelax,
			url: 'https://account.bigpond.com/siteminderagent/nocert/{TIMESTAMP}/smgetcred.scc?TYPE=16777217&REALM=$SM$Toolbar&TARGET=$SM$https%3a%2f%2faccount%2ebigpond%2ecom%2fbroadband%2fusage%2ftoolbar%2ftoolbar%2edo',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'https://telstra.com/siteminderagent/login/bdumcustlogin.fcc?TYPE=33554432&REALMOID=&GUID=&SMAUTHREASON=0&TARGET=$SM$https://telstra.com/tcoma/security/login2-sm.asp%3fform=bdumcust_,_AUTH_REDIR=https://account.bigpond.com/broadband/usage/secure/monthlyusage.do',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			strToInt: function (m, s) {
				// bigpond 10GB "unlimited" plan is actually -1 MB ?!
				i = parseInt(s, 10);
				if (i == -1 && m == 'qt') i = 10000;
				return i;
			},

			xpVerify: '/bigpond[@version="1.1"]/usage/account',

			xpUpload: '/bigpond/usage/account/upload',
			xpDownload: '/bigpond/usage/account/download',
			xpLimit: '/bigpond/usage/account/limit',

			xpRecorded: '/bigpond/usage/account/recorded'
		}
	case 'netspace':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://usage.netspace.net.au/usage-meter/adslusage?version=2&granularity=MONTH',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'http://my.netspace.net.au/usage-meter/timestat0',
			usagePageAuth: nuISPAuthBasic,
			usagePageAuthRealm: 'myNetspace',

			xpError: '/opt/@ERROR',

			xpVerify: '/USAGE[@VERSION="2"]/TRAFFIC',
			xpPlanName: '/USAGE/PLAN/@DESCRIPTION',

			xpStartDate: '/USAGE/@START_DATE',
			xpEndDate: '/USAGE/@END_DATE',

			//xpUpload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
			//xpDownload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
			//xpLimit: '/USAGE/PLAN/LIMIT[@NAME="Standard"]/@MEGABYTES',
			xpUpload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
			xpLimit: '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',

			//xpUploadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
			//xpDownloadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
			xpUploadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownloadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',

			xpUploadP: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownloadP: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
			xpLimitP: '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',
			xpUploadPO: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
			xpDownloadPO: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',
			xpLimitPO: '/USAGE/PLAN/LIMIT[@NAME="Off Peak"]/@MEGABYTES',

			xpUploadFP: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownloadFP: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
			xpUploadFPO: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
			xpDownloadFPO: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',

		}
	case 'iinet':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			regexp1P: / ([0-9]+) MB Peak time, ([0-9]+) MB Bliinktime[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
			regexpErr: /Please enter your Username and Password/,

			iPlanName: 0,

			iStartDate: 3,
			iEndDate: 4,

			iUploadP: 0,
			iDownloadP: 5,
			iLimitP: 1,
			iUploadPO: 0,
			iDownloadPO: 7,
			iLimitPO: 2,

			iUploadF: 0,
			iDownloadF: 6,
		}
	case 'iinetb2':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			regexp1P: / ([0-9]+) MB Peak time, ([0-9]+) MB[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
			regexpErr: /Please enter your Username and Password/,

			iPlanName: 0,

			iStartDate: 3,
			iEndDate: 4,

			iUploadP: 0,
			iDownloadP: 5,
			iLimitP: 1,
			iUploadPO: 0,
			iDownloadPO: 6,
			iLimitPO: 2,

			iUploadF: 0,
			iDownloadF: 7,
		}

	case 'internode':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://accounts.internode.on.net/cgi-bin/padsl-usage',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://accounts.internode.on.net/cgi-bin/login',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}&access=Personal_ADSL',

			regexp1: /([0-9\.]+) ([0-9]+) ([0-9\/]+)/,
			regexpErr: /([^\r\n]+)/,

			iPlanName: 0,

			iNextRollDate: 3,

			iUpload: 0,
			iDownload: 1,
			iLimit: 2,
		}
	case 'optus':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://myaccount.optusnet.com.au/mydatamonitor/usage.txt',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'login={USERNAME}&passwd={PASSWORD}',

			usagePageUrl: 'https://myaccount.optusnet.com.au/mydatamonitor/index.html',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'u=&username={USERNAME}&password={PASSWORD}',

			regexp1: /last=([0-9:\- ]+)[^`]+?plan_limit=([0-9]+)MB[^`]+?plan_name=([^\r\n]+)[^`]+?throttled=([0-9]+)[^`]+?usage=([0-9]+)MB/,
			regexpErr: /error=1[^`]+?reason=([^\r\n]+)/,

			iPlanName: 3,

			iUpload: 0,
			iDownload: 5,
			iLimit: 2,
			iRecorded: 1,
		}
	case 'swiftdsl':
		return {
			id: isp,
			description: 'Please manually enter your usage quota.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://members.swiftdsl.com.au/usage.php',
			url: 'https://members.swiftdsl.com.au/usage.php',
			urlLogout: 'https://members.swiftdsl.com.au/main.php?logout=y',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://members.swiftdsl.com.au/usage.php',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}',


			strToInt: function (m, s) {
				if (m == 'qt') {
					return 16000;
				} else {
					return Math.round(s);
				}
			},

			regexp1P: /<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>[0-9\.]*<\/b>.*<b>[0-9\.]*<\/b>.*<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>/,
			regexp1: /<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>[0-9\.]*<\/b>.*<b>([0-9\.]*)<\/b>/,
			regexpErr: / is invalid Please try again/,

			iPlanName: 0,

			iUpload: 0,
			iDownload: 1,
			iDownloadF: 2,
			iRecorded: 3,
			iLimit: 0,

			iUploadP: 0,
			iUploadPO: 0,

			iDownloadP: 1,
			iDownloadPO: 2,
			iDownloadFP: 3,
			iDownloadFPO: 4,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'aanet':
		return {
			id: isp,
			description: 'Please manually enter your usage quota',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			url: 'https://www.aanet.com.au/usage2.php?{USERNAME},{PASSWORD}',
			urlAuth: nuISPAuthGet,

			usagePageUrl: 'https://www.aanet.com.au/members/checkuser.php',
			usagePageAuth: nuISPAuthGet,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			strToInt: function (m, s) {
				return Math.round(s/1048576);
			},

			regexp1: /([0-9]+),([0-9]+),([0-9:\- ]+),([0-9]+)/,
			regexpErr: /[	 ]*([^\r\n]+)/,

			iPlanName: 0,

			iNextRollDay: 4,

			iUpload: 1,
			iDownload: 2,
			iLimit: 0,
			iRecorded: 3,
		}
	case 'exetel':
		return {
			id: isp,
			description: 'Please manually enter your usage quota and start day.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.exetel.com.au/members/usage_monthly_query.php',
			url: 'https://www.exetel.com.au/members/usage_monthly_query.php',
			urlLogout: 'https://www.exetel.com.au/members/logout.php',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			usagePageUrl: 'https://www.exetel.com.au/members/usage_monthly_query.php',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',


			regexp1P: /Total:[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>/,

			regexpErr: /The Service Number and Password you have entered is invalid/,

			iPlanName: 0,

			iUploadP: 3,
			iUploadPO: 1,

			iDownloadP: 4,
			iDownloadPO: 2,
			iDownloadFP: 0,
			iDownloadFPO: 0,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'exetelwireless':
		return {
			id: isp,
			description: 'Please manually enter your usage quota and start day.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.exetel.com.au/wireless_login/usage_monthly_query.php',
			url: 'https://www.exetel.com.au/wireless_login/usage_monthly_query.php',
			urlLogout: 'https://www.exetel.com.au/wireless_login/logout.php',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			usagePageUrl: 'https://www.exetel.com.au/wireless_login/usage_monthly_query.php',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',


			regexp1P: /Total:[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>/,

			regexpErr: /The Service Number and Password you have entered is invalid/,

			iPlanName: 0,

			iUploadP: 3,
			iUploadPO: 1,

			iDownloadP: 4,
			iDownloadPO: 2,
			iDownloadFP: 0,
			iDownloadFPO: 0,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'pacnet':
		return {
			id: isp,
			description: 'Please manually enter your usage quota.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.pacific.net.au/highlander/validate.jsp',
			url: 'https://www.pacific.net.au/highlander/usageview.jsp?zoom=no&past=0&mode=tabular',
			urlLogout: 'https://www.pacific.net.au/highlander/logout.jsp',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}&realm=pacific.net.au',

			usagePageUrl: 'https://www.pacific.net.au/highlander/usageview.jsp?zoom=no&past=0&mode=tabular',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}&realm=pacific.net.au',



			regexp1: /selected>([\/0-9]+) - ([\/0-9]+)[^`]+href="trafficviewselector\.jsp\?zoom=period">[^`]+right>([0-9\.]+)[^`]+right>([0-9\.]+)[^`]+right>([0-9\.]+)[^`]+right>([0-9\.]+)/,

			regexpErr: /Login failed! Please try again./,

			iPlanName: 0,

			iStartDate: 1,
			iEndDate: 2,

			iUpload: 3,
			iUploadF: 5,

			iDownload: 4,
			iDownloadF: 6,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'globaldial':
		return {
			id: isp,
			description: '',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			url: 'http://www.globaldial.com/cgi-bin/adsl-usage.cgi',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}&mode=login',

			usagePageUrl: 'http://www.globaldial.com/cgi-bin/adsl-usage.cgi',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}&mode=login',


			regexp1P: /ADSL plan is the ([A-Za-z0-9 \/]+), which includes ([0-9]+)MB peak and ([0-9]+)MB/,

			regexpErr: /Incorrect username or password/,

			iPlanName: 1,

			iUploadP: 0,
			iUploadPO: 0,

			iDownloadP: 5,
			iDownloadPO: 6,
			iDownloadFP: 0,
			iDownloadFPO: 0,

			iLimitP: 2,
			iLimitPO: 3,
		}
	case 'tpgi':
		return {
			id: isp,
			description: 'Please manually enter your usage limit.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			url: 'https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'check_username={USERNAME}&password={PASSWORD}&Submit=GO!',

			usagePageUrl: 'https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'check_username={USERNAME}&password={PASSWORD}&Submit=GO!',

			strToDate: function (m, s) {
				//13 Sep 2004
				var a = /([0-9]+) ([A-Za-z]+) ([0-9]+)/.exec(s);
					return new Date(a[3], month3l[a[2]], a[1], 23, 59, 59);
			},

			regexp1: /<b>Package Type:<\/b> ([A-Za-z 0-9\.]+)[^`]+?<b>Download Charges:<\/b> ([A-Za-z0-9 :]+)[^`]+?Expiry Date:<\/b> ([A-Za-z0-9 ]+)[^`]+?Period:<\/b> Ends: ([A-Za-z0-9 ]+)[^`]+?Charges: (\$[0-9\.]+)[^`]+?Download used: ([0-9\.]+) MB/,

			regexpErr: /Invalid username or customer ID or password/,

			iPlanName: 1,

			iNextRollDate: 4,

			iDownload: 6,
			//iLimit: 2,
		}
	case 'iprimus':
		return {
			id: isp,
			description: 'Please manually enter your usage quota.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://toolbox.iprimus.com.au/verifypwd.asp?Username={USERNAME}&Password={PASSWORD}&URL=%2FUsageOverall.asp&timezoneoffset=-660&submit=Login',
			url: 'https://toolbox.iprimus.com.au/UsageOverall.asp',
			urlLogout: 'https://toolbox.iprimus.com.au/logout.asp',
			urlAuth: nuISPAuthCookieGet,
			urlAuthPostData: 'Username={USERNAME}&Password={PASSWORD}&URL=%2FUsageOverall.asp&timezoneoffset=-660&submit=Login',

			usagePageUrl: 'https://toolbox.iprimus.com.au/verifypwd.asp',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'Username={USERNAME}&Password={PASSWORD}&URL=%2FUsageOverall.asp&timezoneoffset=-660&submit=Login',

			// this is a potentially dangerous regexp, iprimus page makes it hard for mozilla regexp to parse
			// only essential values are captured to minimize delay
			regexp1: /Period from ([A-Za-z0-9, ]+?) to ([A-Za-z0-9, ]+?)<\/b><\/span>[^\r\n]*[\r\n]+<br><b> Plan name : <\/b> ([A-Za-z0-9 ]+)[\r\n]+[^\r\n]+[\r\n]+[^\r\n]+?clsTableBody">[^\r\n]+?clsTableBody">[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">[^\r\n]+[\r\n]+<\/table><br><br>/,
			//regexp2: /Period from ([A-Za-z0-9, ]+?) to ([A-Za-z0-9, ]+?)<\/b><\/span>[^\r\n]*[\r\n]+<br><b> Plan name : <\/b> ([A-Za-z0-9 ]+)[\r\n]+[^\r\n]+[\r\n]+[^\r\n]+?clsTableBody">[^\r\n]+?clsTableBody">([A-Za-z0-9&; ]+)[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">([^<]+)[^\r\n]+[\r\n]+<\/table><br><br>/,

			regexpErr: /Log in using your username and password/,


			strToDate: function (m, s) {
				//Thursday, 7 October 2004
				var a = /[^,]+, ([0-9]+) ([A-Za-z]+) ([0-9]+)/.exec(s);
					return new Date(a[3], month3l[a[2].substr(0,3)], a[1], 23, 59, 59);
			},


			iPlanName: 3,

			iStartDate: 1,
			iEndDate: 2,

			iUpload: 4,

			iDownload: 5,

			iLimit: 0,

			// re2:
			// total time 4
			// last recorded session 7
		}



	/*
	Doesn't work :(

	case 'telecomnz':
		return {
			id: isp,
			description: 'Please manually enter your usage limit.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			url: 'https://jetstream-usage.telecom.co.nz/cgi-bin/iaf/iafReports',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'IAF_SERVER_SERVICE=iafserver&IAF_SERVER=se259&HGE_LOCALE=hgeTemplates/csc/&formEvent=generate&formName=cscUserUsageBasic.html&SCLValidationMessage=cscErrorPassword.html&IAF_userID=&IAF_customerNumber=&IAF_LogonType=USER&IAF_LogonUserID={USERNAME}&IAF_LogonPassword={PASSWORD}',

			usagePageUrl: 'https://jetstream-usage.telecom.co.nz/cgi-bin/iaf/iafReports',
			usagePageAuth: nuISPAuthPost,
			urlAuthPostData: 'IAF_SERVER_SERVICE=iafserver&IAF_SERVER=se259&HGE_LOCALE=hgeTemplates/csc/&formEvent=generate&formName=cscUserUsageBasic.html&SCLValidationMessage=cscErrorPassword.html&IAF_userID=&IAF_customerNumber=&IAF_LogonType=USER&IAF_LogonUserID={USERNAME}&IAF_LogonPassword={PASSWORD}',

			strToDate: function (m, s) {
				//13 Sep 2004
				var a = /([0-9]+) ([A-Za-z]+) ([0-9]+)/.exec(s);
				if (m == 'start')
					return new Date(a[3], month3l[a[2]], a[1], 0, 0, 0);
				else
					return new Date(a[3], month3l[a[2]], a[1], 23, 59, 59);
			},

			regexp1: /Usage for ([A-Za-z 0-9]+) - ([A-Za-z 0-9]+)<\/H2>[^`]+Current period usage plan:<\/TD><TD ALIGN=LEFT>([A-Za-z 0-9]+)<\/TD>[^`]+?Total:<\/TD>[^`]+?([0-9.]+)[ ]*MB[^`]+?This Meter reflects your usage up to ([0-9 :\/on]+)<\/TD>/,

			regexpErr: /INCORRECT LOGIN/,

			iPlanName: 3,

			iStartDate: 1,
			iEndDate: 2,

			iDownload: 4,
			iLimit: 0,

			iRecorded: 5,
		} */



	case 'netcabo':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: 'Please manually enter usage limit. OffPeak=International',
			mode: nuISPRelax,
			url: 'http://maps.netcabo.pt/netcabo/trafego_m1_taxas.asp',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'http://maps.netcabo.pt/netcabo/trafego_m1_taxas.asp',
			usagePageAuth: nuISPAuthBasic,


			regexp1P: /MBytes Internacionais<\/td>[^`]+?Total<\/td>[^`]+?>([0-9]+)<\/td>[^`]+?([0-9]+)<\/td>/,

			iPlanName: 0,

			iDownloadP: 1,
			iDownloadPO: 2,
			iLimitP: 0,
			iLimitPO: 0,
		}






	case 'coditel':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: 'Please enter the ESN in the username field',
			mode: nuISPRelax,
			url: 'http://www.coditel.net/ENcm_counters.asp?ESN={USERNAME}&action=CheckESN',
			urlAuth: nuISPAuthGet,

			usagePageUrl: 'http://www.coditel.net/ENcm_counters.asp?ESN={USERNAME}&action=CheckESN',
			usagePageAuth: nuISPAuthGet,

			strToInt: function (m, s) {
				if (m == 'qt') {
					return 15000;
				} else {
					// numbers are gigabytes
					// commas are decimal in the page
					d = new Number(s.replace(/,/, '.'));
					return Math.round(d*1000);
				}
			},

			regexp1: /Download used this month : ([0-9,]+) GBytes<br>Upload used this month : ([0-9,]+) GBytes/,

			iPlanName: 0,

			iUpload: 2,
			iDownload: 1,
			iLimit: 0,
		}
	}

	return null;

}
