/*

The NetUsage Project
http://netusage.mozdev.org/


Copyright (C) 2004, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage Installation Script

*/

startInstall();

function startInstall() {
	var NUI_VERSION = '0.6.4';

	initInstall('NetUsage ToolBar Installation', 'netusageitem', NUI_VERSION, 0);
	logComment('NetUsage: Installation Started');

	var compFolder = getFolder('components');
	//var chromeFolder = getFolder('Profile', 'chrome');
	var chromeFolder = getFolder('chrome');
	addFile('/netusage.mozdev.org/netusagebtn', NUI_VERSION, 'chrome/netusagebtn.jar', chromeFolder, '');
	addFile('/netusage.mozdev.org/netusagecom', NUI_VERSION, 'components/nsNetUsageCom.js', compFolder, '');
	addFile('/netusage.mozdev.org/netusagedata', NUI_VERSION, 'components/nsINetUsageData.xpt', compFolder, '');

	if (checkStep('Extracting files - Please ensure you have the correct file writing permissions'))
		return;

	registerChrome(CONTENT | DELAYED_CHROME, getFolder('chrome', 'netusagebtn.jar'), 'content/');
	registerChrome(SKIN | DELAYED_CHROME, getFolder('chrome', 'netusagebtn.jar'), 'skin/classic/');
	registerChrome(LOCALE | DELAYED_CHROME, getFolder('chrome', 'netusagebtn.jar'), 'locale/en-AU/netusagebtn/');
	//registerChrome(CONTENT | PROFILE_CHROME, getFolder(chromeFolder, 'netusagebar.jar'), 'content/');

	if (checkStep('Registering chrome - Please ensure you have the correct file writing permissions to the chrome DB'))
		return;

	// get rid of old overlayinfo
	if (File.isDirectory(getFolder(getFolder(getFolder('chrome', 'overlayinfo'), 'browser'), 'content'))) {
		File.dirRemove(getFolder(getFolder(getFolder('chrome', 'overlayinfo'), 'browser'), 'content'), true);
	}

	// START INSTALL
	performInstall();

	if (checkStep('Performing Install'))
		return;


	// return different messages depending if it's mozilla or firebird.
	if (File.exists(getFolder(getFolder('chrome'), 'browser.jar')))
		alert("Net Usage Item has been installed.\nPlease restart Mozilla.\n\nAfter restarting, please:\n- Goto extension options to configure the extension.\n- Customize the toolbars to drag the usage metre out.");
	else
		alert("Net Usage Item has been installed.\nPlease restart Mozilla.\n\nAfter restarting, please:\n- Goto Preferences > Advanced > Net Usage Item to configure the extension.");

	logComment('NetUsage: All done');

}

function checkStep(msg) {
	var err = getLastError()

	if (err != SUCCESS && err != REBOOT_NEEDED) {
		logComment('NetUsage [FAILED] '+err+' while: '+msg);
		cancelInstall();

		alert("An Error ("+err+") has occured while "+msg+"\nInstallation has been aborted");
		return true;
	}
}